;**************************************************************
;
;	BANKS - Displays bank usage statistics.  Based on the
;		BANKSTAT program that was supplied with the
;		HD64180 XLR8er board for the TRS-80 Model 4/4P.
;
;	Modifications to original code by PFM Software
;	from JBSoft.  This program is freely donated to
;	the public domain.
;
;	Syntax: BANKS
;
;	Programmer: Rex A. Basham
;	Date:	    12/29/87
;
;**************************************************************
;
ETX	EQU	03H
LF	EQU	0AH
CR	EQU	0DH
;
@CLS	EQU	69H
@DSP	EQU	02H
@DSPLY	EQU	0AH
@EXIT	EQU	16H
@BANK	EQU	66H
;
SVC	MACRO	#ADDR
	LD	A,#ADDR
	RST	28H
	ENDM
;
	ORG	3000H
;
BEGIN	SVC	@CLS		;Clear the video and...
	LD	HL,HEADER	;...crank out the table
	SVC	@DSPLY
;
	LD	C,0FFH		;Set for initial increment to go to 0
	LD	B,2		;Test BUR for bank in use
LOOP1	INC	C
	PUSH	BC		;Save test bank number
	SVC	@BANK
	LD	C,'+'
	JR	Z,OKAY		;Bank is available for use
;
	POP	BC		;P/U test bank number
	PUSH	BC		;Save it again
	LD	B,1		;Try to reset BUR for bank available
	SVC	@BANK
	LD	C,'-'
	JR	NZ,OKAY		;Bank is not installed
	POP	BC		;P/U test bank number
	PUSH	BC		;Save it again
	LD	B,3		;If we get here, Bank was already in use...
	SVC	@BANK		;...so set BUR to reprotect the Bank...
	LD	C,'*'		;...and tell us it's here but unavailable.
;
OKAY	SVC	@DSP		;Output the indicator
	POP	BC		;P/U test bank number
	PUSH	BC		;Save it again
	LD	A,C
	CP	0AH		;Last bank?
	LD	C,' '
	LD	B,2
	JR	Z,LOOP2		;Yes. 2 spaces.
	LD	B,4		;No. 4 spaces.
LOOP2	SVC	@DSP
	DJNZ	LOOP2
	POP	BC
	LD	A,C
	CP	0AH
	JR	NZ,LOOP1	;Back for another bank
;
	LD	HL,LAST		;Terminate the table...
	SVC	@DSPLY
	LD	HL,0
	SVC	@EXIT		;...and return to DOS
;
HEADER	DB	0BFH
	DC	63,83H
	DB	0BFH,LF,0BFH,'  C U R R E N T   M E M O R Y   B A N K   '
	DB	'S T A T I S T I C S  ',0BFH,LF,0BFH
	DC	19,8CH
	DB	0ACH,9CH
	DC	21,8CH
	DB	0ACH,9CH
	DC	19,8CH
	DB	0BFH,LF,0BFH,'  ''+'' = Available  ',0AAH,095H
	DB	'  ''-'' = Unavailable  ',0AAH,095H
	DB	'  ''*'' = In Use     ',0BFH,LF,0BFH
	DC	63,83H
	DB	0BFH,LF,0BFH,'  Bank#: <0>  <1>  <2>  <3>  <4>  <5>  <6>  '
	DB	'<7>  <8>  <9> <10> ',0BFH,LF,0BFH
	DC	63,8CH
	DB	0BFH,LF,0BFH,'  Status: ',ETX
LAST	DB	0BFH,LF
	DC	65,083H
	DB	CR
	END	BEGIN
